/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package maths;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;

/**
 *
 * @author connie
 */
public class DoingPOST {
    private final static String SCRIPT = "server.php";
    public final static String SERVER = "http://diacalc.org/dbwork/";
    private String answer = "";
    private String errorMsg = "";
    private boolean error = false;
    
    public static String checkServerPath(String v){
        if (v==null || v.length()==0) return SERVER;
        if (!v.endsWith("/")) return v+"/";
        return v;
    }
    public DoingPOST(String pathToServer, String request){
        URL                 url;
        URLConnection       urlConn;
        DataOutputStream    printout;
        
        try{
            url = new URL (checkServerPath(pathToServer) + SCRIPT);
            urlConn = url.openConnection();
            urlConn.setDoInput (true);
            urlConn.setDoOutput (true);
            urlConn.setUseCaches (false);

            // Specify the content type.
            urlConn.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
            printout = new DataOutputStream (urlConn.getOutputStream ());

            printout.writeBytes (request);
            printout.flush ();
            printout.close ();

            // Get response data.
            BufferedReader rd = new BufferedReader(new InputStreamReader(urlConn.getInputStream(),"UTF8"));

            String line;
            while (null != ((line = rd.readLine())))
            {
                answer += line;
            }
            rd.close ();
            if (!answer.endsWith("<ok>")){
                error = true;
                errorMsg = answer;
            }
        }
        catch(Exception ex){
            errorMsg += "Exception while connecting to the server:"+ex.getMessage();
            error = true;
        }
        
        answer = answer.replace("<br>", "\n");
    }
    public String getAnswer(){
        return answer;
    }
    public boolean isError(){
        return error;
    }
    public String getErrorMessage(){
        return errorMsg;
    }
}
